package com.lyq.autocall;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.media.AudioManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {
	SharedPreferences sharedPreferences;//ĺ
	EditText edt1, edt2;
	TextView tv1, tv2;
	Button btn1, btn2, btn3;
	Thread thread;
	int repeatCount = 0;
	int amount;
	String number, tag = "MainActivity";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		edt1 = (EditText) findViewById(R.id.edittext1);
		edt2 = (EditText) findViewById(R.id.edittext2);
		tv1 = (TextView) findViewById(R.id.textview1);
		tv2 = (TextView) findViewById(R.id.textview2);
		btn1 = (Button) findViewById(R.id.button1);
		btn2 = (Button) findViewById(R.id.button2);
		btn3 = (Button) findViewById(R.id.button3);
		//һȼ ͣļ
		sharedPreferences = getSharedPreferences("phones", MODE_PRIVATE);
		edt1.setText(sharedPreferences.getString("number", ""));
		btn1.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Զɵķ
				if (edt1.getText().toString().trim().length() > 5
						&& edt2.getText().toString().trim().length() > 0) {
					//ǵ绰룬򲦴
					number = edt1.getText().toString().trim();
					Editor editor = sharedPreferences.edit();
					editor.putString("number", number);
					editor.commit();
					//getString()ڶΪȱʡֵpreferenceвڸkeyȱʡֵ
					Toast.makeText(getApplicationContext(),
							"AutoCallڴȥҶز", Toast.LENGTH_SHORT).show();
					amount = Integer.parseInt(edt2.getText().toString().trim());
					end2doCall();
				} else if (edt1.getText().toString().trim().length() <= 5) {
					//ʾ
					Toast.makeText(getApplicationContext(),
							"⵽ķֻ룬ɵ˰ɣ", Toast.LENGTH_SHORT).show();
				} else {
					Toast.makeText(getApplicationContext(), "ףٲһѽ",
							Toast.LENGTH_SHORT).show();
				}

			}
		});
		btn2.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Զɵķ
				if (edt1.getText().toString().trim().length() > 5
						&& edt2.getText().toString().trim().length() > 0) {
					//ǵ绰룬򲦴
					number = edt1.getText().toString().trim();
					Editor editor = sharedPreferences.edit();
					editor.putString("number", number);
					editor.commit();
					//getString()ڶΪȱʡֵpreferenceвڸkeyȱʡֵ
					amount = Integer.parseInt(edt2.getText().toString().trim());
					if (thread == null) {
						Toast.makeText(getApplicationContext(),
								"AutoCallڴȥԶز", Toast.LENGTH_SHORT).show();
						thread = new Thread(new Runnable() {
							@Override
							public void run() {
								// TODO Auto-generated method stub
								handler.sendEmptyMessage(0);
							}
						});
						thread.start();
						Log.i(tag, "thread started");
					} else {
						Toast.makeText(getApplicationContext(), "ڲ绰أ",
								Toast.LENGTH_SHORT).show();
					}
					//					autoCall();
				} else if (edt1.getText().toString().trim().length() <= 5) {
					//ʾ
					Toast.makeText(getApplicationContext(),
							"⵽ķֻ룬ɵ˰ɣ", Toast.LENGTH_SHORT).show();
				} else {
					Toast.makeText(getApplicationContext(), "ףٲһѽ",
							Toast.LENGTH_SHORT).show();
				}
			}
		});
		btn3.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Զɵķ
				Toast.makeText(getApplicationContext(), "ֹͣԶز",
						Toast.LENGTH_SHORT).show();
				StopThread();
				MainActivity.this.finish();
			}
		});

	}

	protected void end2doCall() {
		// TODO Զɵķ

	}

	Handler handler = new Handler() {

		@SuppressLint("HandlerLeak")
		@Override
		public void handleMessage(Message msg) {
			super.handleMessage(msg);
			if (repeatCount >= amount) {
				StopThread();
				tv2.setText("Ѳ\n" + repeatCount + "");

			} else {
				RepeatDial();
				tv2.setText("Ѳ\n" + repeatCount + "");
			}
		}
	};

	private void RepeatDial() {
		MyPhoneStateListener myPhoneStateListener = new MyPhoneStateListener();//½һ绰
		TelephonyManager telephonyManager = (TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);//½һ绷
		telephonyManager.listen(myPhoneStateListener,
				PhoneStateListener.LISTEN_CALL_STATE);
	}

	public class MyPhoneStateListener extends PhoneStateListener {
		@Override
		public void onCallStateChanged(int state, String phoneNumber) {
			switch (state) {
			case TelephonyManager.CALL_STATE_IDLE:
				if (repeatCount <= amount && thread != null) {
					repeatCount++;
					Intent intent = new Intent(Intent.ACTION_CALL,
							Uri.parse("tel:" + number));
					startActivity(intent);

					Toast.makeText(MainActivity.this, "ڲ绰",
							Toast.LENGTH_LONG).show();
				} else {
					StopThread();
				}
				break;
			case TelephonyManager.CALL_STATE_OFFHOOK:
				break;
			case TelephonyManager.CALL_STATE_RINGING:
				break;
			default:
				break;
			}
		}
	}

	/**
	 * 
	 * 
	 * @param context
	 */
	public void toggleSpeaker(Context context) {
		AudioManager am = (AudioManager) context
				.getSystemService(Context.AUDIO_SERVICE);
		am.setMode(AudioManager.MODE_IN_CALL);
		am.setSpeakerphoneOn(!am.isSpeakerphoneOn());
	}

	private void StopThread() {
		if (thread != null) {
			//Ҫ̵ֹͣ߳interrupt()Ϊ߳пwait()sleep(), ̵ֹͣ߳ļʱ
			thread.interrupt();
			//ʹ			thread.stop();
			thread = null;
			Log.i(tag, "thread stoped");
		}
	}

	public void autoCall() {
		// parse
		Intent intent = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"
				+ number));
		//֪ͨactivtitycall
		MainActivity.this.startActivity(intent);
	}

}
